GNU bug report logs - #28083
Two patches for grep on Windows, fixing directory recursion and leaking color

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: grep; Reported by: Stephan Lavavej <stl@HIDDEN>; Keywords: patch; Done: Paul Eggert <eggert@HIDDEN>; Maintainer for grep is bug-grep@HIDDEN.

Message received at 28083-done <at> debbugs.gnu.org:


Received: (at 28083-done) by debbugs.gnu.org; 17 Nov 2021 20:34:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 17 15:34:29 2021
Received: from localhost ([127.0.0.1]:34011 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mnRdV-0005j2-4O
	for submit <at> debbugs.gnu.org; Wed, 17 Nov 2021 15:34:29 -0500
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:45558)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1mnRdU-0005ip-AC
 for 28083-done <at> debbugs.gnu.org; Wed, 17 Nov 2021 15:34:28 -0500
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 05AB01600AD;
 Wed, 17 Nov 2021 12:34:23 -0800 (PST)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id 5YVYKbnGR9a6; Wed, 17 Nov 2021 12:34:22 -0800 (PST)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 1A0CA1600C5;
 Wed, 17 Nov 2021 12:34:22 -0800 (PST)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id erj31xIL67_D; Wed, 17 Nov 2021 12:34:22 -0800 (PST)
Received: from [192.168.1.9] (cpe-172-91-119-151.socal.res.rr.com
 [172.91.119.151])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id E54E61600AD;
 Wed, 17 Nov 2021 12:34:21 -0800 (PST)
Message-ID: <d4cc1e5e-82af-dbfe-5e8c-30fb8671e245@HIDDEN>
Date: Wed, 17 Nov 2021 12:34:21 -0800
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.2.1
Subject: Re: Two patches for grep on Windows, fixing directory recursion and
 leaking color
Content-Language: en-US
To: "Stephan T. Lavavej" <stl@HIDDEN>
References: <5b879ae0-a502-9a1c-2788-4c8896c23796@HIDDEN>
 <733220bf-d99c-0c0b-3ace-5a2e6274ea6b@HIDDEN>
 <CACHw8XL5Z3tLxQXPutKf6mzuTu23HtE7ve7BMYZYX5FZLHSUyQ@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
In-Reply-To: <CACHw8XL5Z3tLxQXPutKf6mzuTu23HtE7ve7BMYZYX5FZLHSUyQ@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.4 (--)
X-Debbugs-Envelope-To: 28083-done
Cc: 28083-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.4 (---)

On 11/17/21 04:37, Stephan T. Lavavej wrote:
> I found that the copyright assignment process was more burdensome than I
> expected (in particular, the request for employer signoff), so I abandoned
> the attempt.

Oh well. Thanks for letting us know. Closing the bug report.




Notification sent to Stephan Lavavej <stl@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Paul Eggert <eggert@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 17 Nov 2021 12:37:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 17 07:37:32 2021
Received: from localhost ([127.0.0.1]:60386 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mnKBw-0007OB-Cu
	for submit <at> debbugs.gnu.org; Wed, 17 Nov 2021 07:37:32 -0500
Received: from mail-ed1-f44.google.com ([209.85.208.44]:44927)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stl@HIDDEN>) id 1mnKBs-0007Nt-TD
 for 28083 <at> debbugs.gnu.org; Wed, 17 Nov 2021 07:37:30 -0500
Received: by mail-ed1-f44.google.com with SMTP id z10so10354734edc.11
 for <28083 <at> debbugs.gnu.org>; Wed, 17 Nov 2021 04:37:28 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=nuwen-net.20210112.gappssmtp.com; s=20210112;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=AIOYoLHsYuJ1Czpcg0JTrZzaqIYx4GQE0Bv0r14HYeM=;
 b=RbC48hH+vrDbXuF2gfsPuuXWfXC7SP/jgVSVeTDLNf+dPiJLq8HUZLklRtZeuZ/wJe
 RQ7KxFQPpTYq+uZU5OcFo1FlHRB3eBkL5gNISfUrYk2qbL2wEiyJpO+F9L3VAOXVrZ8u
 dEtNB1lahtb66D1re+Eh4/hyZETJzOREgX/px9EUHnVbDLC6xL4kIUGRkUzmSNPxtUGB
 KFZEa1MpYaxASK94abRqq3HBL8ITKN4E0693lhmxfiylKifkhLJot/yiVJ0JHO4wJvMp
 oHt3WRDdgCK2OBVoouO0WALs9zuAgLhqgHoP7QACB1asDIKFtvAJslmUkGX2NbpGyKL6
 qnhg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=AIOYoLHsYuJ1Czpcg0JTrZzaqIYx4GQE0Bv0r14HYeM=;
 b=VuS6Vw4DFnDEm8dsi2fuypgYM7+claheyYavWMZKAUtcIvuW7HiYl2QTm88voVSrml
 +9wf/DTITaIJcCPt4qSYm158I9j7Yc5nG/ot8LLrfNDA2p+qTjqaVXJSj5n2bhP/G3Sj
 HyoiZujNaNrnadfQQmR2ed8iwEzmwuUyS1nm1oGbO/y1/KjIn7GItSBRu/UAc2RVyhUY
 6pKciW5h/ekVHgrFzmJHzsFwYfjjHQFhen7imfMLVkgtlS7yip+U9SpjaNj2oWleBvNA
 lL9ESJ6AKQI5UbQWoB8+CZVlmi/vnzJy9PydeUBnGe+9dcAncSksi2SZAWOgE0nyjZTu
 FF+Q==
X-Gm-Message-State: AOAM532Yf+VROXxiQ6xC10mQeNNcZ6xLAK4vmZWbPoK8A4Zw9oGneXyD
 Pw/UMdHIqiBdqFNf6OzibueE41WEy++Hynl/FUGi4Q==
X-Google-Smtp-Source: ABdhPJxTwgGS7OXBUYTpV14sRkS3hV74jE9CwTCWctiWSjYugX/26bixE4+/xZSfV+V6GsD56qlow/qE4Z5U/FXCNls=
X-Received: by 2002:a50:fe8e:: with SMTP id d14mr22074305edt.51.1637152642879; 
 Wed, 17 Nov 2021 04:37:22 -0800 (PST)
MIME-Version: 1.0
References: <5b879ae0-a502-9a1c-2788-4c8896c23796@HIDDEN>
 <733220bf-d99c-0c0b-3ace-5a2e6274ea6b@HIDDEN>
In-Reply-To: <733220bf-d99c-0c0b-3ace-5a2e6274ea6b@HIDDEN>
From: "Stephan T. Lavavej" <stl@HIDDEN>
Date: Wed, 17 Nov 2021 04:37:11 -0800
Message-ID: <CACHw8XL5Z3tLxQXPutKf6mzuTu23HtE7ve7BMYZYX5FZLHSUyQ@HIDDEN>
Subject: Re: Two patches for grep on Windows, fixing directory recursion and
 leaking color
To: Paul Eggert <eggert@HIDDEN>
Content-Type: multipart/alternative; boundary="000000000000b8e3d305d0fb4d53"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 28083
Cc: 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000b8e3d305d0fb4d53
Content-Type: text/plain; charset="UTF-8"

I found that the copyright assignment process was more burdensome than I
expected (in particular, the request for employer signoff), so I abandoned
the attempt. Please go ahead and close this bug, if nobody wants to attempt
to implement a fix from scratch.

Thanks (and apologies for the delayed reply),
STL

On Sun, Nov 14, 2021 at 1:34 PM Paul Eggert <eggert@HIDDEN> wrote:

> Stephan, I'm following up on GNU grep Bug#28303
> <https://debbugs.gnu.org/28083> dated 2017-08-13, which ends with this
> email from you dated 2019-12-31:
>
> > I'd still like to
> > get this patch in, so let's restart. I kept my branch around and the
> patch
> > rebased cleanly (with a trivial merge to NEWS). I'll email the FSF this
> > week.
>
> I don't see any record of your assigning copyright to the FSF since
> then, which means your patch still isn't in GNU grep. If you're still
> interested in getting it done please let us know, and we can restart the
> process again.
>

--000000000000b8e3d305d0fb4d53
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"auto">I found that the copyright assignment process was more bu=
rdensome than I expected (in particular, the request for employer signoff),=
 so I abandoned the attempt. Please go ahead and close this bug, if nobody =
wants to attempt to implement a fix from scratch.</div><div dir=3D"auto"><b=
r></div><div dir=3D"auto">Thanks (and apologies for the delayed reply),</di=
v><div dir=3D"auto">STL</div><div><br><div class=3D"gmail_quote"><div dir=
=3D"ltr" class=3D"gmail_attr">On Sun, Nov 14, 2021 at 1:34 PM Paul Eggert &=
lt;<a href=3D"mailto:eggert@HIDDEN">eggert@HIDDEN</a>&gt; wrote:<=
br></div><blockquote class=3D"gmail_quote" style=3D"margin:0px 0px 0px 0.8e=
x;border-left-width:1px;border-left-style:solid;padding-left:1ex;border-lef=
t-color:rgb(204,204,204)">Stephan, I&#39;m following up on GNU grep Bug#283=
03 <br>
&lt;<a href=3D"https://debbugs.gnu.org/28083" rel=3D"noreferrer" target=3D"=
_blank">https://debbugs.gnu.org/28083</a>&gt; dated 2017-08-13, which ends =
with this <br>
email from you dated 2019-12-31:<br>
<br>
&gt; I&#39;d still like to<br>
&gt; get this patch in, so let&#39;s restart. I kept my branch around and t=
he patch<br>
&gt; rebased cleanly (with a trivial merge to NEWS). I&#39;ll email the FSF=
 this<br>
&gt; week.<br>
<br>
I don&#39;t see any record of your assigning copyright to the FSF since <br=
>
then, which means your patch still isn&#39;t in GNU grep. If you&#39;re sti=
ll <br>
interested in getting it done please let us know, and we can restart the <b=
r>
process again.<br>
</blockquote></div></div>

--000000000000b8e3d305d0fb4d53--




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 14 Nov 2021 21:35:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 14 16:35:02 2021
Received: from localhost ([127.0.0.1]:51906 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mmN9S-0000Rg-1q
	for submit <at> debbugs.gnu.org; Sun, 14 Nov 2021 16:35:02 -0500
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:56092)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1mmN9Q-0000RP-LZ
 for 28083 <at> debbugs.gnu.org; Sun, 14 Nov 2021 16:35:00 -0500
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 425EB1600EA;
 Sun, 14 Nov 2021 13:34:55 -0800 (PST)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id dUhBL7bT9Y3G; Sun, 14 Nov 2021 13:34:52 -0800 (PST)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 857191600EF;
 Sun, 14 Nov 2021 13:34:52 -0800 (PST)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id INA9ynhKn_A7; Sun, 14 Nov 2021 13:34:52 -0800 (PST)
Received: from [192.168.1.9] (cpe-172-91-119-151.socal.res.rr.com
 [172.91.119.151])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 60F3F1600EA;
 Sun, 14 Nov 2021 13:34:52 -0800 (PST)
Message-ID: <733220bf-d99c-0c0b-3ace-5a2e6274ea6b@HIDDEN>
Date: Sun, 14 Nov 2021 13:34:52 -0800
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.2.1
Subject: Re: Two patches for grep on Windows, fixing directory recursion and
 leaking color
Content-Language: en-US
From: Paul Eggert <eggert@HIDDEN>
To: Stephan Lavavej <stl@HIDDEN>
References: <5b879ae0-a502-9a1c-2788-4c8896c23796@HIDDEN>
Organization: UCLA Computer Science Department
In-Reply-To: <5b879ae0-a502-9a1c-2788-4c8896c23796@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.4 (--)
X-Debbugs-Envelope-To: 28083
Cc: 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.4 (---)

Stephan, I'm following up on GNU grep Bug#28303 
<https://debbugs.gnu.org/28083> dated 2017-08-13, which ends with this 
email from you dated 2019-12-31:

> I'd still like to
> get this patch in, so let's restart. I kept my branch around and the patch
> rebased cleanly (with a trivial merge to NEWS). I'll email the FSF this
> week.

I don't see any record of your assigning copyright to the FSF since 
then, which means your patch still isn't in GNU grep. If you're still 
interested in getting it done please let us know, and we can restart the 
process again.




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 31 Dec 2019 20:44:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 31 15:44:49 2019
Received: from localhost ([127.0.0.1]:35241 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1imONk-0000do-OJ
	for submit <at> debbugs.gnu.org; Tue, 31 Dec 2019 15:44:48 -0500
Received: from mail-ed1-f67.google.com ([209.85.208.67]:33829)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stl@HIDDEN>) id 1imONi-0000da-Kw
 for 28083 <at> debbugs.gnu.org; Tue, 31 Dec 2019 15:44:47 -0500
Received: by mail-ed1-f67.google.com with SMTP id l8so35998968edw.1
 for <28083 <at> debbugs.gnu.org>; Tue, 31 Dec 2019 12:44:46 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=nuwen-net.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=B+oKUSek0RDSJWX/xPnG8cfTapsetCckZLiIWMeg9rA=;
 b=ouMeikaUCzJafrUB1pKrWn3OlvdofmPRowuKw95U5KoB41CJ8E2yBL+GqwBdOrv35l
 Wk9ZhxHJKWcmyXW4/V+5GKtgN7+yPnVCWIh/xBzE/rWD6qH4oy7q3ggP0S3BDdJ7sWOl
 JwzqYJg4OyAOaltu0m7vuX0j+iVHvZTUzff5sIsTtN5GnmrHG1vhcX9IzGOXw9w8/f5v
 1TPLj5AvRZeHPhbk1/5UyLhHHgquO/w3FTx1Ri+8SQlObV0M77brN9wJyrQia0KDcf6C
 gOVMjGlsW7iTOc6naXWejXO1h1DE0Q50sFNKDwO3Nh/P+pyRThoWIs9ngOXMbRqDX9TO
 2iAg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=B+oKUSek0RDSJWX/xPnG8cfTapsetCckZLiIWMeg9rA=;
 b=C8YK8kUvlKQTn7WLRH40Ii4WCtQ3y9b3AC2B8NaO7k8CNCGhjhRF/uYWAZ/ra6xic+
 k5NOE2yCnOtrBZV5X1b4kbxsgbJxzbi/CKg2vQ1rGPcwLvHyHNoYqZfvsg0ssM22JkSy
 dFSr28IKPC7jBhlDVaoVrM1x4UWYIUgMOalbo/X4Mhbqjei8FlDGHE+Ar230PYkvsbYD
 sNBwlGL1zTycfV0Uv4ASCIDMeCnV3xXbPru/hUzjtpVbHTY+Jg+hGwWrstjvy5hVRNof
 FR1Ydgr/Ct/z3FhbbwALGcgW1lNgAC09CEeRSjD6QI1UOArMk289+mzeUSeEULLh9yno
 LPvw==
X-Gm-Message-State: APjAAAWBxocKuoDH9fTCgz5tQWo80KQdBDT5OrrY+xDcOMUFNuxbb4R0
 rEWNytk478PxJxGpYNSVunmzRqy4Vo4Hkz1As5ctIg==
X-Google-Smtp-Source: APXvYqxzXyKAzATj80NxhtmL7XRDkmb7qIxTqpDcoEz7obMLz+BLrmx+dYDhDlY1APvoGjKZ3rzEhaHBC82qYyzUbzQ=
X-Received: by 2002:a17:906:b212:: with SMTP id
 p18mr79889380ejz.208.1577825080680; 
 Tue, 31 Dec 2019 12:44:40 -0800 (PST)
MIME-Version: 1.0
References: <5b879ae0-a502-9a1c-2788-4c8896c23796@HIDDEN>
In-Reply-To: <5b879ae0-a502-9a1c-2788-4c8896c23796@HIDDEN>
From: "Stephan T. Lavavej" <stl@HIDDEN>
Date: Tue, 31 Dec 2019 12:44:29 -0800
Message-ID: <CACHw8XJJw7MuJm0pfdX+0AWik6xFuLorKMJbL7sMeRPijH0gcw@HIDDEN>
Subject: Re: Two patches for grep on Windows, fixing directory recursion and
 leaking color
To: Paul Eggert <eggert@HIDDEN>
Content-Type: multipart/alternative; boundary="00000000000073b89d059b06078a"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 28083
Cc: Jim Meyering <jim@HIDDEN>, 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--00000000000073b89d059b06078a
Content-Type: text/plain; charset="UTF-8"

Hi Paul,

Thanks for the reminder; this got buried in my todo list and I didn't get
around to requesting the copyright assignment paperwork. I'd still like to
get this patch in, so let's restart. I kept my branch around and the patch
rebased cleanly (with a trivial merge to NEWS). I'll email the FSF this
week.

STL

On Tue, Dec 31, 2019 at 11:45 AM Paul Eggert <eggert@HIDDEN> wrote:

> Stephan, I'm following up on GNU grep Bug#28303 <
> https://debbugs.gnu.org/28083>
> dated 2017-08-13, which says:
>
> >> However, the second is substantial enough that
> >> before I can use it, you'll have to follow the instructions in the
> >> "Copyright assignment" section of that same HACKING file.  Can you do
> >> that?
> >
> > Sure, I'll start that process.
>
> As far as I can tell that process never finished, which means your patch
> still
> isn't in GNU grep. If you're still interested in getting it done please
> let us
> know, and we can restart the process.
>

--00000000000073b89d059b06078a
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">Hi Paul,<div><br></div><div>Thanks for the reminder; this =
got buried in my todo list and I didn&#39;t get around to requesting the co=
pyright assignment paperwork. I&#39;d still like to get this patch in, so l=
et&#39;s restart. I kept my branch around and the patch rebased cleanly (wi=
th a trivial merge to NEWS). I&#39;ll email the FSF this week.</div><div><b=
r></div><div>STL</div></div><br><div class=3D"gmail_quote"><div dir=3D"ltr"=
 class=3D"gmail_attr">On Tue, Dec 31, 2019 at 11:45 AM Paul Eggert &lt;<a h=
ref=3D"mailto:eggert@HIDDEN">eggert@HIDDEN</a>&gt; wrote:<br></di=
v><blockquote class=3D"gmail_quote" style=3D"margin:0px 0px 0px 0.8ex;borde=
r-left:1px solid rgb(204,204,204);padding-left:1ex">Stephan, I&#39;m follow=
ing up on GNU grep Bug#28303 &lt;<a href=3D"https://debbugs.gnu.org/28083" =
rel=3D"noreferrer" target=3D"_blank">https://debbugs.gnu.org/28083</a>&gt;<=
br>
dated 2017-08-13, which says:<br>
<br>
&gt;&gt; However, the second is substantial enough that<br>
&gt;&gt; before I can use it, you&#39;ll have to follow the instructions in=
 the<br>
&gt;&gt; &quot;Copyright assignment&quot; section of that same HACKING file=
.=C2=A0 Can you do<br>
&gt;&gt; that?<br>
&gt; <br>
&gt; Sure, I&#39;ll start that process.<br>
<br>
As far as I can tell that process never finished, which means your patch st=
ill<br>
isn&#39;t in GNU grep. If you&#39;re still interested in getting it done pl=
ease let us<br>
know, and we can restart the process.<br>
</blockquote></div>

--00000000000073b89d059b06078a--




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 31 Dec 2019 19:45:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 31 14:45:59 2019
Received: from localhost ([127.0.0.1]:35171 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1imNSp-0002RU-3c
	for submit <at> debbugs.gnu.org; Tue, 31 Dec 2019 14:45:59 -0500
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:41274)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1imNSn-0002LR-0V
 for 28083 <at> debbugs.gnu.org; Tue, 31 Dec 2019 14:45:57 -0500
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 9F2C416027C;
 Tue, 31 Dec 2019 11:45:51 -0800 (PST)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id 6nhfxfxAuJqR; Tue, 31 Dec 2019 11:45:50 -0800 (PST)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id CB1B716027E;
 Tue, 31 Dec 2019 11:45:50 -0800 (PST)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id Ldksq-DtAS8f; Tue, 31 Dec 2019 11:45:50 -0800 (PST)
Received: from [192.168.1.9] (cpe-23-242-74-103.socal.res.rr.com
 [23.242.74.103])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id A25F216027C;
 Tue, 31 Dec 2019 11:45:50 -0800 (PST)
To: Stephan Lavavej <stl@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Subject: Re: Two patches for grep on Windows, fixing directory recursion and
 leaking color
Organization: UCLA Computer Science Department
Message-ID: <5b879ae0-a502-9a1c-2788-4c8896c23796@HIDDEN>
Date: Tue, 31 Dec 2019 11:45:50 -0800
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.2.2
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 28083
Cc: Jim Meyering <jim@HIDDEN>, 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Stephan, I'm following up on GNU grep Bug#28303 <https://debbugs.gnu.org/28083>
dated 2017-08-13, which says:

>> However, the second is substantial enough that
>> before I can use it, you'll have to follow the instructions in the
>> "Copyright assignment" section of that same HACKING file.  Can you do
>> that?
> 
> Sure, I'll start that process.

As far as I can tell that process never finished, which means your patch still
isn't in GNU grep. If you're still interested in getting it done please let us
know, and we can restart the process.




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.
Added tag(s) pending and patch. Request was from Paul Eggert <eggert@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 27 Nov 2017 04:19:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 26 23:19:30 2017
Received: from localhost ([127.0.0.1]:59896 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eJAtG-0003EH-Ed
	for submit <at> debbugs.gnu.org; Sun, 26 Nov 2017 23:19:30 -0500
Received: from mail-it0-f42.google.com ([209.85.214.42]:46450)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stl@HIDDEN>) id 1eJAtE-0003E2-5Z
 for 28083 <at> debbugs.gnu.org; Sun, 26 Nov 2017 23:19:28 -0500
Received: by mail-it0-f42.google.com with SMTP id t1so2181849ite.5
 for <28083 <at> debbugs.gnu.org>; Sun, 26 Nov 2017 20:19:28 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=nuwen-net.20150623.gappssmtp.com; s=20150623;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc; bh=+eyl33Gd2W4HglX98kMt8I6eu6PzRdFAj6MJqpHQJ7A=;
 b=wTXt81VNKX+Z3fZCriRtCZJAUSzlTyWpWZCm0VRH+r5OnuNlZbuFH/okidCOKz+I6m
 G890OCsBlvqd/SAlrECjidMKcTPmkflEFg512l/lkDEUHaA4sxm4p61W6uhxFD13gHp3
 18GgpNqEGw14j6DMlnl9kcSWyfr+GZLR1wTE85wkkotaoAIHqCQ5KjxsboRMv0cdoyhs
 XHOwbQZsZNkTiKTjHSLiHF4sP1gwunpbsYRbrp9vRORT6T5kwmQjvXw+piWfcXnaCY67
 1l4Zqy0j0LVAr+xbJnzxZRYM00n9GYz+QuVaNwtO8M+YQPS6280UGOd1SyIHZJAgoY2H
 UNSg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:in-reply-to:references:from:date
 :message-id:subject:to:cc;
 bh=+eyl33Gd2W4HglX98kMt8I6eu6PzRdFAj6MJqpHQJ7A=;
 b=ItHcWq4UpdSJxO8TkXIbWItBjyRXKOstpytEBRKdpZ3cCDbovaawOw5OMh6OAUv9tW
 kwrn+4qnGkhI/UFEEdMzmt3qJSUTvXAEAIjfZ0jB7rUxb/J2AH+Y/iO+E/5OmHHnw1+n
 QGbLRcv11a1TvQtB9XfmoawDfxbt1AimD7SLdIewkhHKJYVKT5rK68sKKm+79aJqKK/+
 onPyPxUOjFtoz1fHkhgojsMfRFjGymGmH81fXxFk9w/hjNAHIRUxkOzQ1P9oh6y2zsMR
 GG7WB+8IT+n6Z4bonXr5RPY97vrwj6r6ulKi4gejGuCuHpO/dO57ojKCzTeXoYvnsLL8
 O/Aw==
X-Gm-Message-State: AJaThX4j9LCduQfps427HjSASHNcaeNs+/ngShcfrrEs0F5HilZARpf4
 +w/DTHqmJRXIkrwH0GAqw5i12tY9hbEGWoWG6Pj8ye1i
X-Google-Smtp-Source: AGs4zMYOTTwYKFGUFT4ZWbFqaLW0aaBRVsjGvQD7xhLL7RoiBqrhBWAny0gGiqL4+yVn6ovNQo0PyFihWGESvyCUFvg=
X-Received: by 10.36.190.199 with SMTP id i190mr25520455itf.84.1511756362419; 
 Sun, 26 Nov 2017 20:19:22 -0800 (PST)
MIME-Version: 1.0
Received: by 10.2.91.71 with HTTP; Sun, 26 Nov 2017 20:19:21 -0800 (PST)
X-Originating-IP: [50.35.73.161]
In-Reply-To: <CA+8g5KFF8ovFSOr+y9qGCUhZuH8QE8dNSq0QWE1YeDE7pWZdSQ@HIDDEN>
References: <CACHw8XKa-xFpUXJ407-5P2i1DEdTp4hEwvZBRMO9N6y9Ui45rg@HIDDEN>
 <CACHw8XJ_N3NBL0wmQWyq+h7Au7C2ezvkCmnF12EUStaKet=Stg@HIDDEN>
 <CA+8g5KEKQzCKM48z2S8g3KYEB7+mQc4mH___mnd-+xW0z8eDfw@HIDDEN>
 <CACHw8XKwqggouj2SzSXLobVPkvrWi65GuoMyauOkriFTt3fGwg@HIDDEN>
 <CA+8g5KFF8ovFSOr+y9qGCUhZuH8QE8dNSq0QWE1YeDE7pWZdSQ@HIDDEN>
From: Stephan Lavavej <stl@HIDDEN>
Date: Sun, 26 Nov 2017 20:19:21 -0800
Message-ID: <CACHw8X+5-qjvKA+3U9ftqsPR97zuY8RsZCQTC-be40Q-uf2m1Q@HIDDEN>
Subject: Re: bug#28083: Two patches for grep on Windows, fixing directory
 recursion and leaking color
To: Jim Meyering <jim@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 28083
Cc: 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

On Sun, Nov 26, 2017 at 3:58 PM, Jim Meyering <jim@HIDDEN> wrote:
> [for reference, we're discussing these:
> https://debbugs.gnu.org/db/28/28083.html]

On Sun, Nov 26, 2017 at 6:58 PM, Jim Meyering <jim@HIDDEN> wrote:
> I made only these changes to the commit log before pushing that:
> - removed capitalization and trailing period from the one-line summary
> in the log message
> - added ChangeLog-style "* FILENAME (function): Sentence/phrase
> describing the change" line for each modified file.

Great, thank you so much!

> Please follow suit for your next patch(es).

Will do. Here's my current NEWS entry and commit message, if you're
interested. I've tried to follow the ChangeLog style. I'll send out a
git format-patch when the paperwork is complete.

NEWS entry:

  On MS-Windows, when grep is printing colorized output and is
  terminated prematurely by Ctrl+C, grep now restores the console's
  original color.
  [bug present since grep 2.11 added colorization for MS-Windows]

Commit message:

grep: reset MS-Windows console color after Ctrl+C

grep implements colorized output on MS-Windows with
SetConsoleTextAttribute(). However, if grep is terminated prematurely
by Ctrl+C when it's in the middle of printing colorized output, the
MS-Windows console won't reset the color. This results in "leaking
color", where the prompt is displayed in whatever color that grep was
using for highlighting. The console's color can be restored by running
"color 07" (or whatever the normal color is), but the problem can be
avoided completely.

Fixing this problem is fairly simple. The MS-Windows API provides
SetConsoleCtrlHandler(), allowing a program to intercept Ctrl+C (and
Ctrl+Break, which is identically affected). On MS-Windows, Ctrl+C works
by injecting an additional thread into the process. Note that this
patch isn't introducing this thread - it's always injected by Ctrl+C,
which uses a default handler to terminate the process. This patch
simply adds an additional handler to be called. So to avoid leaking
color, we need to:

1. Initialize a critical section, which cannot fail on MS-Windows Vista
and newer. (On older versions of MS-Windows, it can fail under
conditions of extremely low memory, which isn't a concern in practice.)

2. Whenever we're about to colorize the output, enter the critical
section and check a bool (initially true) saying whether we're allowed
to colorize. If so, call SetConsoleTextAttribute() while still inside
that critical section. If not, do nothing.

3. During initialization, use SetConsoleCtrlHandler() to add a small
function that will be called when Ctrl+C (or Ctrl+Break) is pressed.
This will enter the critical section, restore the console's text color,
and set the bool to false.

The critical section is necessary because when MS-Windows injects the
thread for Ctrl+C, the main thread can be busy toggling the color on
and off. By resetting the text color and setting the bool to false, the
main thread is prevented from re-colorizing the console.

(The main thread also calls SetConsoleTextAttribute() at the end of
colorized regions. This doesn't need to be guarded by the critical
section, since repeatedly restoring the console's color is perfectly
fine.)

As the changes are limited to colorize-w32.c, no other platforms are
affected.

* lib/colorize-w32.c (color_lock): Add static CRITICAL_SECTION.
(color_bool): Add static BOOL, initialized to TRUE.
(w32_color_handler): When handling a Ctrl+C or Ctrl+Break event, lock
color_lock, restore the console's color, and set color_bool to FALSE in
order to prevent re-colorization. Return FALSE, so the default handler
will be called next.
(init_colorize): After initializing hstdout and norm_attr, initialize
color_lock, then set w32_color_handler to handle signals for this
process.
(print_start_colorize): To prevent re-colorization, guard
SetConsoleTextAttribute by locking color_lock and testing color_bool.
* NEWS (Bug fixes): Mention this fix.

Thanks,
STL




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 27 Nov 2017 02:58:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 26 21:58:48 2017
Received: from localhost ([127.0.0.1]:59864 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eJ9dA-0001G9-IL
	for submit <at> debbugs.gnu.org; Sun, 26 Nov 2017 21:58:48 -0500
Received: from mail-qk0-f179.google.com ([209.85.220.179]:39087)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1eJ9d8-0001Fv-GN
 for 28083 <at> debbugs.gnu.org; Sun, 26 Nov 2017 21:58:46 -0500
Received: by mail-qk0-f179.google.com with SMTP id w125so30700906qkb.6
 for <28083 <at> debbugs.gnu.org>; Sun, 26 Nov 2017 18:58:46 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:sender:in-reply-to:references:from:date:message-id
 :subject:to:cc;
 bh=Y3Qfwv4EbkPNo9oUmsYw5HeaqDTk6r1VLPOsBdXEz50=;
 b=EQSUUjDz+OzqrK97GIhZwilWb5uRSJsbLwwVykvdFKB/3y7egKWjyOBNYZQpp5E+l9
 7rfbLUe3MiQESnN2gHrkG1NHqY4sXHYYubNBEMetQDJY0NBParakcjrbFKCitJuSkad0
 uGjup860bdUL76o3/gTNps/Iv4iHTHwsAWxkJVpYIrBSwYLd84ZQKB4hQbmvqphBmtOK
 hTEDSIjYDtkKsHIZ/vo1i3Q31lrmTNrzmHHDdduuFFLSHr6f2J61VQZyVhmafSMMMJNr
 YX+Q9xzxLbKpgYMmPGp32sV9O4hbOp29PeKs4DoovYK0OHnQv1h8zyUi9N3PTOvZtvuz
 /02g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:sender:in-reply-to:references:from
 :date:message-id:subject:to:cc;
 bh=Y3Qfwv4EbkPNo9oUmsYw5HeaqDTk6r1VLPOsBdXEz50=;
 b=hZ3dpiYHCsVO29NYCwxl3SctWbUkT4CQAwqIAZVWxVmsA6nqlsLVU9ti3qCwUHeVeD
 DH6q6A8skjm5+6qe8BGhHdoBhXTRupH+yYAY1Ci9j4TnT9EWLH3+8tTRnY22LudJMwra
 N839OHpQcgvIy7K1QUP3cmtz/CE/atuES+CFz55qccRGPjVAaH6i34daJ5ZbNGMjpfNH
 or/kUIU/bgG9LljcrhSaXufqb4p35kNU848ce+mpfivB4n6MqpfAw4AKHwoQ543RqhLw
 2rmCyuOa064dqM8MKjzUlhoeveoMc0JHp6vgK3x1cmZczW2cAYS3XySYCXaCNR10RizP
 OzYQ==
X-Gm-Message-State: AJaThX4lvg7IZmzUq9z08q6Zj9m1uQjELOedV4u+X2vdAKNR4LyWbeD7
 22F8Cmxj/I5DMLvLCWaVmlCx7E15c8IYw9qWxDM=
X-Google-Smtp-Source: AGs4zMZEkOln4PYH3N1ynKIxL+gEQ0CJAGUYK9iRa9rSYRNWDWvI/I8rUZN4pAtQIfM8ixABJqtyZ3g9tQ32sGSIwe4=
X-Received: by 10.55.109.4 with SMTP id i4mr22112347qkc.17.1511751520958; Sun,
 26 Nov 2017 18:58:40 -0800 (PST)
MIME-Version: 1.0
Received: by 10.55.9.17 with HTTP; Sun, 26 Nov 2017 18:58:19 -0800 (PST)
In-Reply-To: <CACHw8XKwqggouj2SzSXLobVPkvrWi65GuoMyauOkriFTt3fGwg@HIDDEN>
References: <CACHw8XKa-xFpUXJ407-5P2i1DEdTp4hEwvZBRMO9N6y9Ui45rg@HIDDEN>
 <CACHw8XJ_N3NBL0wmQWyq+h7Au7C2ezvkCmnF12EUStaKet=Stg@HIDDEN>
 <CA+8g5KEKQzCKM48z2S8g3KYEB7+mQc4mH___mnd-+xW0z8eDfw@HIDDEN>
 <CACHw8XKwqggouj2SzSXLobVPkvrWi65GuoMyauOkriFTt3fGwg@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Sun, 26 Nov 2017 18:58:19 -0800
X-Google-Sender-Auth: zATCeVoREUm-O_YWrEvnpG02ers
Message-ID: <CA+8g5KFF8ovFSOr+y9qGCUhZuH8QE8dNSq0QWE1YeDE7pWZdSQ@HIDDEN>
Subject: Re: bug#28083: Two patches for grep on Windows, fixing directory
 recursion and leaking color
To: Stephan Lavavej <stl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 28083
Cc: 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

On Sun, Nov 26, 2017 at 6:13 PM, Stephan Lavavej <stl@HIDDEN> wrote:
> On Sun, Nov 26, 2017 at 3:58 PM, Jim Meyering <jim@HIDDEN> wrote:
>> [for reference, we're discussing these:
>> https://debbugs.gnu.org/db/28/28083.html]
>> Thank you for preparing those.
>
> You're welcome!
>
>> Would you please follow the contribution guidelines in grep's HACKING
>> file, https://git.savannah.gnu.org/cgit/grep.git/tree/HACKING to
>> create two git change sets? Since each fixes a bug, each should also
>> add a brief comment to the NEWS file.
>>
>> Your first patch is tiny and looks fine, so I can apply it with no
>> paperwork required.
>
> Great, I've attached the output of git format-patch for that one.
> Please let me know if you need it in a different form.

I made only these changes to the commit log before pushing that:
- removed capitalization and trailing period from the one-line summary
in the log message
- added ChangeLog-style "* FILENAME (function): Sentence/phrase
describing the change" line for each modified file.

Please follow suit for your next patch(es).
Thanks,
Jim




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 27 Nov 2017 02:13:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 26 21:13:30 2017
Received: from localhost ([127.0.0.1]:59833 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eJ8vJ-0006hg-RW
	for submit <at> debbugs.gnu.org; Sun, 26 Nov 2017 21:13:30 -0500
Received: from mail-it0-f54.google.com ([209.85.214.54]:44892)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stl@HIDDEN>) id 1eJ8vH-0006hQ-Hy
 for 28083 <at> debbugs.gnu.org; Sun, 26 Nov 2017 21:13:27 -0500
Received: by mail-it0-f54.google.com with SMTP id b5so19131127itc.3
 for <28083 <at> debbugs.gnu.org>; Sun, 26 Nov 2017 18:13:27 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=nuwen-net.20150623.gappssmtp.com; s=20150623;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc; bh=U4IRvz2YXnnVSMOwHHGp2re0NKJROa+iO2HIwENWomc=;
 b=Fs5uU4vO7NKxH451HHQOK5pf6sefu8oCRNasyAM0ATt/lfgv7V5YgPiz2sZoA+F2KP
 un13YOZNzsCfbdLAiS513pbQKDf+9VqFQAglAPtgDc5nQC9EFJfnfEVJ7Nb/74uca1ja
 Dj7cMWH62yG8dMmQvI+DIqZ5xnSfCwGZkW/6jHuf1qIAqMy70/CrRJx0PQdvub3k8KiZ
 4ltNAbi8UcKNijkinr+Wz5d/nYvtbv6Op574W2vTGPiNJX6QSuwkl1rCBrSS/Tev8c1l
 TduviMrpDRJi+tew34pPbBhiLT1973BNsF8ePWnX8aSotUHF9VvGT9bAW43zy31E6LXi
 c9aQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:in-reply-to:references:from:date
 :message-id:subject:to:cc;
 bh=U4IRvz2YXnnVSMOwHHGp2re0NKJROa+iO2HIwENWomc=;
 b=AijhsZnnWTHt/t3G4JGLJTFj68pPf3kllS/tIOJZMwKAKrPCg9jVXPJPNtTYUGlGLO
 8W5CRpb/a+9p+osVcwCKVXd0d2e22zAS//6m+SPUEYb9mDQ54zH1cEUL3X3jM+Fu76El
 UVH6IRgFZiVg+sOjuCehQPTpJl8xQVUIVTThTdbXD4exXTbWstSvNjfi+PpCfcz6ENCB
 TnfrLOtoX1OEuUvEryplNx+0O3s24/NW/xLY9TWKK61xwSmPMyf3fvPOGVD+wH0sePX4
 mfPPczHBfkKtZw61nuiqxYjX4SdH/Ejp6bMzdiq1eOdy/gkMIl+I2PzGVhoE0pP7BLDd
 W3OQ==
X-Gm-Message-State: AJaThX7bdTHJKfCWc1YjRDYCob3eCKqreUEy2IWy53AO2i4mi74tjR05
 ipxrCSVJ6X6+GY2l2rsNrAP0W+c2VFwAP2iFFw9Bvk1I
X-Google-Smtp-Source: AGs4zMZutLwzNl0iJvY+JLXK9RLRLJvDHNngFqL++OlcqsJc/Yp2qPSTpIVw5oCyeyIsIZZDFdVCMGBHYZ5hCopCBUI=
X-Received: by 10.36.86.84 with SMTP id o81mr27727355itb.31.1511748801963;
 Sun, 26 Nov 2017 18:13:21 -0800 (PST)
MIME-Version: 1.0
Received: by 10.2.91.71 with HTTP; Sun, 26 Nov 2017 18:13:21 -0800 (PST)
X-Originating-IP: [50.35.73.161]
In-Reply-To: <CA+8g5KEKQzCKM48z2S8g3KYEB7+mQc4mH___mnd-+xW0z8eDfw@HIDDEN>
References: <CACHw8XKa-xFpUXJ407-5P2i1DEdTp4hEwvZBRMO9N6y9Ui45rg@HIDDEN>
 <CACHw8XJ_N3NBL0wmQWyq+h7Au7C2ezvkCmnF12EUStaKet=Stg@HIDDEN>
 <CA+8g5KEKQzCKM48z2S8g3KYEB7+mQc4mH___mnd-+xW0z8eDfw@HIDDEN>
From: Stephan Lavavej <stl@HIDDEN>
Date: Sun, 26 Nov 2017 18:13:21 -0800
Message-ID: <CACHw8XKwqggouj2SzSXLobVPkvrWi65GuoMyauOkriFTt3fGwg@HIDDEN>
Subject: Re: bug#28083: Two patches for grep on Windows, fixing directory
 recursion and leaking color
To: Jim Meyering <jim@HIDDEN>
Content-Type: multipart/mixed; boundary="001a1140576c551c15055eed729c"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 28083
Cc: 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a1140576c551c15055eed729c
Content-Type: text/plain; charset="UTF-8"

On Sun, Nov 26, 2017 at 3:58 PM, Jim Meyering <jim@HIDDEN> wrote:
> [for reference, we're discussing these:
> https://debbugs.gnu.org/db/28/28083.html]
> Thank you for preparing those.

You're welcome!

> Would you please follow the contribution guidelines in grep's HACKING
> file, https://git.savannah.gnu.org/cgit/grep.git/tree/HACKING to
> create two git change sets? Since each fixes a bug, each should also
> add a brief comment to the NEWS file.
>
> Your first patch is tiny and looks fine, so I can apply it with no
> paperwork required.

Great, I've attached the output of git format-patch for that one.
Please let me know if you need it in a different form.

> However, the second is substantial enough that
> before I can use it, you'll have to follow the instructions in the
> "Copyright assignment" section of that same HACKING file.  Can you do
> that?

Sure, I'll start that process.

Thanks,
STL

--001a1140576c551c15055eed729c
Content-Type: application/octet-stream; 
	name="0001-grep-Fix-directory-recursion-on-MS-Windows.patch"
Content-Disposition: attachment; 
	filename="0001-grep-Fix-directory-recursion-on-MS-Windows.patch"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_jahk4zks0
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--001a1140576c551c15055eed729c--




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 26 Nov 2017 23:59:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 26 18:59:05 2017
Received: from localhost ([127.0.0.1]:59790 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eJ6pE-0001aS-PQ
	for submit <at> debbugs.gnu.org; Sun, 26 Nov 2017 18:59:04 -0500
Received: from mail-qt0-f170.google.com ([209.85.216.170]:44202)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1eJ6pD-0001Zy-9p
 for 28083 <at> debbugs.gnu.org; Sun, 26 Nov 2017 18:59:03 -0500
Received: by mail-qt0-f170.google.com with SMTP id h42so37030785qtk.11
 for <28083 <at> debbugs.gnu.org>; Sun, 26 Nov 2017 15:59:03 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:sender:in-reply-to:references:from:date:message-id
 :subject:to:cc;
 bh=AQdyUmKOGsznoBeBQzAzqgxh76jx7A8hYaal+uXqFGI=;
 b=ADlUtt7xlDn6DOHKqzCmL2g8L0BGHpWA5aVB5rE8DHeZf7Vrn9FnCazwJ0vvh4j3Yr
 8wFWUy7g0JkI47l/lAV7Yh2TF+KNLpV7CkWwMsmDQv1QNWw3873KzD4+absctlC2yixT
 YDSFmKSdI5T/qx620FYSwCQHEmaXwYmpzpM2zJsChJrmXqQS3BneWc7FtLu8/jcphiIB
 imECGyX/ehk4SN8UHUacJuvWgFENb25RTBp7fHrbcByCXkoa1FqJnWSaPE9EI0FWUflW
 UG3kwqBzcNQv2pXHE5dobz6kiZoDYky6P2Bo6s10fzZ337oXJvoVTu/GIIaOFoPzGpj2
 qhKQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:sender:in-reply-to:references:from
 :date:message-id:subject:to:cc;
 bh=AQdyUmKOGsznoBeBQzAzqgxh76jx7A8hYaal+uXqFGI=;
 b=o/2SPqz2k2Gf/1KP8xIwX3AJ2yutaQ1pBeeu7qZtxGRMYxbMXSALePH9ufO1/C8Xg2
 S/rTyoMEjh4rkxanqUhtWLZc0db0LUH5ubIN/EJqZSM6hdAMC8Y/RPBxOSrY36GKZt7M
 5fcb09+K3rHJn0wSg/m1+Xfm3kxuP/kZu8HqijK5HovAW4S+QMtfkVswt8rvvo4c6PQp
 EiFqnSiLTJs+4yZ6wFF+UgTRLtx+Ak00GN8evaKGheatmQCdwKqfxzB/vjQMYhmo9Owy
 +lJJ1R0N10C3yF/pLHZrYS9oFC/JLDmfmkUh3Dtkcb9P8iDPk/csfl9ylYDOFVBNbwbW
 Xz4A==
X-Gm-Message-State: AJaThX4/Vkr/7qeEOJV8oGqeoaIb3QoYQJMK3M00VGWMlqCUhvdAzTOT
 pqHT9qaeaLS3fiSmKVRm51fl5l99XO8S99ATcyMzjw==
X-Google-Smtp-Source: AGs4zMYDmbSJdru1nh3QgRDLVZQgouLp/zjDjtVa3R2IwQuv5d10lKJTFScQtX/e52CFmcpmmbhlK2qUx+BiRuaxKnM=
X-Received: by 10.200.46.50 with SMTP id r47mr48533969qta.314.1511740737582;
 Sun, 26 Nov 2017 15:58:57 -0800 (PST)
MIME-Version: 1.0
Received: by 10.55.9.17 with HTTP; Sun, 26 Nov 2017 15:58:36 -0800 (PST)
In-Reply-To: <CACHw8XJ_N3NBL0wmQWyq+h7Au7C2ezvkCmnF12EUStaKet=Stg@HIDDEN>
References: <CACHw8XKa-xFpUXJ407-5P2i1DEdTp4hEwvZBRMO9N6y9Ui45rg@HIDDEN>
 <CACHw8XJ_N3NBL0wmQWyq+h7Au7C2ezvkCmnF12EUStaKet=Stg@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Sun, 26 Nov 2017 15:58:36 -0800
X-Google-Sender-Auth: BpISzMSxjjRjiBUoQcbR0tHo-8A
Message-ID: <CA+8g5KEKQzCKM48z2S8g3KYEB7+mQc4mH___mnd-+xW0z8eDfw@HIDDEN>
Subject: Re: bug#28083: Two patches for grep on Windows, fixing directory
 recursion and leaking color
To: Stephan Lavavej <stl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 28083
Cc: 28083 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

On Sun, Nov 26, 2017 at 1:10 AM, Stephan Lavavej <stl@HIDDEN> wrote:
> On Sun, Aug 13, 2017 at 3:53 PM, Stephan Lavavej <stl@HIDDEN> wrote:
>> I have two patches that improve grep's support for Windows. The first
>> patch is a one-liner that fixes directory recursion, while the second
>> patch fixes "leaking color" when grep is printing colorized output and
>> is terminated prematurely by Ctrl+C.
>
> Is there anything else I can do to help these patches be accepted into master?

[for reference, we're discussing these:
https://debbugs.gnu.org/db/28/28083.html]
Thank you for preparing those.

Would you please follow the contribution guidelines in grep's HACKING
file, https://git.savannah.gnu.org/cgit/grep.git/tree/HACKING to
create two git change sets? Since each fixes a bug, each should also
add a brief comment to the NEWS file.

Your first patch is tiny and looks fine, so I can apply it with no
paperwork required. However, the second is substantial enough that
before I can use it, you'll have to follow the instructions in the
"Copyright assignment" section of that same HACKING file.  Can you do
that?

Thanks,
Jim




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at 28083 <at> debbugs.gnu.org:


Received: (at 28083) by debbugs.gnu.org; 26 Nov 2017 09:10:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 26 04:10:32 2017
Received: from localhost ([127.0.0.1]:58539 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eIsxL-0005dx-Vo
	for submit <at> debbugs.gnu.org; Sun, 26 Nov 2017 04:10:32 -0500
Received: from mail-io0-f182.google.com ([209.85.223.182]:34294)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stl@HIDDEN>) id 1eIsxL-0005dj-46
 for 28083 <at> debbugs.gnu.org; Sun, 26 Nov 2017 04:10:31 -0500
Received: by mail-io0-f182.google.com with SMTP id q101so33244538ioi.1
 for <28083 <at> debbugs.gnu.org>; Sun, 26 Nov 2017 01:10:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=nuwen-net.20150623.gappssmtp.com; s=20150623;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to;
 bh=DlWY+FAqIE5sTfRo6AEkZPmQMLAUkv6nQOodLkgykww=;
 b=IEahqNdEQMa/oKGlYqobwNIA04EmUWaiCRtg248xxIjrOGE24z1afxTQsWS7fvujk4
 LQBCBnsg/tYsd7hgyZNTjrrnzunEvT3mISk1jDOmX3l8oS19RjJJdrcNO6CuJKu/5FW5
 qytJ5arYbBtlpCMOgrLIif3dneXLETwYqt9q5pmZDNQIKCER/DAp4PJfslLMPF42Db0y
 7B5bNe34k646KIfDkjXH7pwlKxiiJYSUFF5KPaJsCBzU4u7nkokG6ldbBdJQb2+faBXF
 fuots42hKtPGGyYMWkSQa8xyqizmK90f12e7qZE1w+FQxSM4rhLureUnX1vUGH4HBlr8
 9/7g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:in-reply-to:references:from:date
 :message-id:subject:to;
 bh=DlWY+FAqIE5sTfRo6AEkZPmQMLAUkv6nQOodLkgykww=;
 b=YfOuUQ5iL4PJMB+ZC8fsa9GX3FefbzvwFcqZdpe8cAk/nvilKMWqBRhrWpI4ntz7to
 AiKGe9ndFSEQGePX/nSrt6E7U8hpQYcjRK75PwGyPMqWiBhQTLCe2uRsNXE5HTLRnMCf
 dVpi/LMLyHmyIYmwwuMDICYrdp63gZlrHc+QNmx3oZkamls9yvqjcaJPK3cYnbCdQwVg
 QlnmPa04maQBGsdHvi2RCJOF3VFJQH8wGwUDttf72MzJ+dLS8DJhjZTYQmD18g7C/zkI
 9iXIr2vCiDVKKG1mxbsiM5U2FwK4BjoeQoK6kf5s/fN5qpbn35dSjXCbVPj6sHY5Qlla
 OEeQ==
X-Gm-Message-State: AJaThX6nEM9ZeHjCAkfv+vjSna92IcmSrU2M1WOo+b/E7g/tov2JKTBJ
 Q4NL3w6GiL2n4CtQBiPknWHy8hm5wwaw3283MZl5Zg==
X-Google-Smtp-Source: AGs4zMYjMCeCqocIXO1UdRz9+JtLRT1EAG4a4zzyyPjbjc8K23e0cNLSLJbvFnIMelnEl2o0XH3S+PhRmGh1W2OaYvI=
X-Received: by 10.107.53.194 with SMTP id k63mr40582765ioo.288.1511687425107; 
 Sun, 26 Nov 2017 01:10:25 -0800 (PST)
MIME-Version: 1.0
Received: by 10.2.91.71 with HTTP; Sun, 26 Nov 2017 01:10:24 -0800 (PST)
X-Originating-IP: [50.35.73.161]
In-Reply-To: <CACHw8XKa-xFpUXJ407-5P2i1DEdTp4hEwvZBRMO9N6y9Ui45rg@HIDDEN>
References: <CACHw8XKa-xFpUXJ407-5P2i1DEdTp4hEwvZBRMO9N6y9Ui45rg@HIDDEN>
From: Stephan Lavavej <stl@HIDDEN>
Date: Sun, 26 Nov 2017 01:10:24 -0800
Message-ID: <CACHw8XJ_N3NBL0wmQWyq+h7Au7C2ezvkCmnF12EUStaKet=Stg@HIDDEN>
Subject: Re: bug#28083: Two patches for grep on Windows, fixing directory
 recursion and leaking color
To: 28083 <at> debbugs.gnu.org
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 28083
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On Sun, Aug 13, 2017 at 3:53 PM, Stephan Lavavej <stl@HIDDEN> wrote:
> I have two patches that improve grep's support for Windows. The first
> patch is a one-liner that fixes directory recursion, while the second
> patch fixes "leaking color" when grep is printing colorized output and
> is terminated prematurely by Ctrl+C.

Is there anything else I can do to help these patches be accepted into master?

Thanks,
STL




Information forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 13 Aug 2017 22:54:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Aug 13 18:54:15 2017
Received: from localhost ([127.0.0.1]:33253 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dh1lv-0001U3-77
	for submit <at> debbugs.gnu.org; Sun, 13 Aug 2017 18:54:15 -0400
Received: from eggs.gnu.org ([208.118.235.92]:57881)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stl@HIDDEN>) id 1dh1lt-0001Tx-RT
 for submit <at> debbugs.gnu.org; Sun, 13 Aug 2017 18:54:14 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <stl@HIDDEN>) id 1dh1lm-0006kX-Rm
 for submit <at> debbugs.gnu.org; Sun, 13 Aug 2017 18:54:08 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,T_DKIM_INVALID
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:44904)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <stl@HIDDEN>) id 1dh1lm-0006kP-Nt
 for submit <at> debbugs.gnu.org; Sun, 13 Aug 2017 18:54:06 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:48850)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <stl@HIDDEN>) id 1dh1lk-0007ZI-Pq
 for bug-grep@HIDDEN; Sun, 13 Aug 2017 18:54:06 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <stl@HIDDEN>) id 1dh1lg-0006h0-RF
 for bug-grep@HIDDEN; Sun, 13 Aug 2017 18:54:04 -0400
Received: from mail-it0-x244.google.com ([2607:f8b0:4001:c0b::244]:35781)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <stl@HIDDEN>) id 1dh1lg-0006g5-Kf
 for bug-grep@HIDDEN; Sun, 13 Aug 2017 18:54:00 -0400
Received: by mail-it0-x244.google.com with SMTP id 76so7007153ith.2
 for <bug-grep@HIDDEN>; Sun, 13 Aug 2017 15:53:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=nuwen-net.20150623.gappssmtp.com; s=20150623;
 h=mime-version:from:date:message-id:subject:to
 :content-transfer-encoding;
 bh=0ssIVd6r2w3+XJFaPbg7tdgRLkX+GbrnakkrC0pr1uk=;
 b=knuctDzlN4t2viruIDyqgVzhB+lstSSGj/AZJ8rSRXQnC1ldPB9NuHDK5szeE7Lmlu
 5eeTmPjhoAmcLYSrPEwxH93D8++WMUmkW51ZQd00LhOLAVAle+7JeixbpEHEAjWpcg4+
 lqWiFohzGJrc/F0VGeySHFtCQ4zVGBVQmiXaDlHyKg06DDsatha7rl6jtARMK8TVf4lc
 RddI8lgHHDf8JVfF0+WKfyliI0jLisL0cA8K1kIghpJb4C6KccZm4GQjTnKCOdb95EwY
 tnYeDoPNIre6YS72qKIauAWWNCCB0hWsSwX0VcN08TwvzG1HNn40Rc4ggtAQNSnfBm5Q
 DNnQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to
 :content-transfer-encoding;
 bh=0ssIVd6r2w3+XJFaPbg7tdgRLkX+GbrnakkrC0pr1uk=;
 b=M2b3pkfQZSEMPli6EbR5aHbPpvJhT1SE0zHGgsAB/CkS9AdK05VLKEjp2iR9Fdfmhc
 V+hfurfTjbwpAxxSDtyw2q20932d9dJMxVTbd4N8QeKs7sae8zv7zZKqKOpgt/Bdt9fo
 ej7LyxLeIaZR7eSifLIvrY4z+5hAe5GMfOhejkFzOT37Re/vPfReLWAKiLAu/8ajjpoy
 Qfpwb9tvJpWH3n4N8vv0sCk0Dctu/+xUPwexnAtSMoafNTLrdcm7GjEvgSID2C0iP46g
 ToEkSx/WD8CB6KyV/1iFVNNgxc+L5+KczKdDHhiKUCafIGlVnbSrgdOEm5i8VF5BGBzl
 U/FQ==
X-Gm-Message-State: AHYfb5iuwModpw0uNeO8L4LtucSKzpE8RtHZPox05DjWSMh/U7Yu/xPl
 sn6tzQh7sTyuN8AT7gEVJsRXv8GJ+xjK69o=
X-Received: by 10.36.135.202 with SMTP id f193mr4125100ite.48.1502664837559;
 Sun, 13 Aug 2017 15:53:57 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.2.88.69 with HTTP; Sun, 13 Aug 2017 15:53:57 -0700 (PDT)
X-Originating-IP: [50.35.79.58]
From: Stephan Lavavej <stl@HIDDEN>
Date: Sun, 13 Aug 2017 15:53:57 -0700
Message-ID: <CACHw8XKa-xFpUXJ407-5P2i1DEdTp4hEwvZBRMO9N6y9Ui45rg@HIDDEN>
Subject: Two patches for grep on Windows, fixing directory recursion and
 leaking color
To: bug-grep@HIDDEN
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

Hi,

I have two patches that improve grep's support for Windows. The first
patch is a one-liner that fixes directory recursion, while the second
patch fixes "leaking color" when grep is printing colorized output and
is terminated prematurely by Ctrl+C.

First patch: gnulib recently gained a module, windows-stat-inodes,
that fixes directory recursion on Windows. No changes to grep's C
sources are required - grep simply needs to request the module during
configuration. Here's how:

###

Add windows-stat-inodes to bootstrap.conf, fixing directory recursion
on Windows.

diff --git a/bootstrap.conf b/bootstrap.conf
index 1c50974..73f1573 100644
--- a/bootstrap.conf
+++ b/bootstrap.conf
@@ -93,6 +93,7 @@ wchar
 wcrtomb
 wctob
 wctype-h
+windows-stat-inodes
 xalloc
 xbinary-io
 xstrtoimax

###

Here's the gnulib commit that added the windows-stat-inodes module:
https://git.savannah.gnu.org/gitweb/?p=3Dgnulib.git;a=3Dcommit;h=3D8123b614=
e616eaa951d842f10730ba7b914f75b3

When grep requests this module, its configure script will gain the
behavior that was implemented in windows-stat-inodes.m4. This detects
mingw and sets WINDOWS_STAT_INODES=3D1. All other platforms are
unaffected, setting WINDOWS_STAT_INODES=3D0 (which is what's happening
in the absence of this patch).

(Credit: Thanks to P=C3=A4r Bj=C3=B6rklund who diagnosed the problem as
involving inodes, which led me to discover the gnulib module, and
thanks to V=C3=A1clav Haisman who provided the bootstrap.conf patch in
https://github.com/StephanTLavavej/mingw-distro/issues/41 .)


Second patch: grep implements colorized output on Windows with
SetConsoleTextAttribute(). However, if grep is terminated prematurely
by Ctrl+C when it's in the middle of printing colorized output, the
Windows console won't reset the color. This results in "leaking
color", where the prompt is displayed in whatever color that grep was
using for highlighting. The console's color can be restored by running
"color 07" (or whatever the normal color is), but the problem can be
avoided completely.

Fixing this problem is fairly simple. The WinAPI provides
SetConsoleCtrlHandler(), allowing a program to intercept Ctrl+C (and
Ctrl+Break, which is identically affected). On Windows, Ctrl+C works
by injecting an additional thread into the process. Note that my patch
isn't introducing this thread - it's always injected by Ctrl+C, which
uses a default handler to terminate the process. My patch simply adds
an additional handler to be called. So to avoid leaking color, we need
to:

1. Initialize a critical section, which cannot fail on Vista and
above. (If anyone cares about XP/2003, it can fail under conditions of
extremely low memory, which isn't a concern in practice.)

2. Whenever we're about to colorize the output, enter the critical
section and check a bool (initially true) saying whether we're allowed
to colorize. If so, call SetConsoleTextAttribute() while still inside
that critical section. If not, do nothing.

3. During initialization, use SetConsoleCtrlHandler() to add a small
function that will be called when Ctrl+C (or Ctrl+Break) is pressed.
This will enter the critical section, restore the console's text
color, and set the bool to false.

The critical section is necessary because when Windows injects the
thread for Ctrl+C, the main thread can be busy toggling the color on
and off. By resetting the text color and setting the bool to false,
the main thread is prevented from re-colorizing the console.

(The main thread also calls SetConsoleTextAttribute() at the end of
colorized regions. This doesn't need to be guarded by the critical
section, since repeatedly restoring the console's color is perfectly
fine.)

I've been using this patch for many years (going back to grep 2.10 in
March 2012 at least, when grep lacked support for color on Windows and
I added it locally). In this patch, I've tried to follow the
surrounding coding conventions to the best of my ability. As the
changes are limited to colorize-w32.c, no other platforms are
affected.

###

On Windows, restore the console's color when Ctrl+C is pressed.

diff --git a/lib/colorize-w32.c b/lib/colorize-w32.c
index 1073018..0ae014b 100644
--- a/lib/colorize-w32.c
+++ b/lib/colorize-w32.c
@@ -32,6 +32,27 @@

 static HANDLE hstdout =3D INVALID_HANDLE_VALUE;
 static SHORT norm_attr;
+static CRITICAL_SECTION color_lock;
+static BOOL color_bool =3D TRUE;
+
+/* After Ctrl+C or Ctrl+Break,
+   restore the normal text attribute used by the console.  */
+static BOOL WINAPI
+w32_color_handler (DWORD ctrl_type)
+{
+  if (ctrl_type =3D=3D CTRL_C_EVENT
+      || ctrl_type =3D=3D CTRL_BREAK_EVENT)
+    {
+      EnterCriticalSection (&color_lock);
+      if (hstdout !=3D INVALID_HANDLE_VALUE)
+        {
+          SetConsoleTextAttribute (hstdout, norm_attr);
+        }
+      color_bool =3D FALSE;
+      LeaveCriticalSection (&color_lock);
+    }
+  return FALSE;
+}

 /* Initialize the normal text attribute used by the console.  */
 void
@@ -45,6 +66,9 @@ init_colorize (void)
      norm_attr =3D csbi.wAttributes;
   else
     hstdout =3D INVALID_HANDLE_VALUE;
+
+  InitializeCriticalSectionAndSpinCount (&color_lock, 4000);
+  SetConsoleCtrlHandler (&w32_color_handler, TRUE);
 }

 /* Return non-zero if we should highlight matches in output.  */
@@ -164,7 +188,12 @@ print_start_colorize (char const *sgr_start, char
const *sgr_seq)
   if (hstdout !=3D INVALID_HANDLE_VALUE)
     {
       SHORT attr =3D w32_sgr2attr (sgr_seq);
-      SetConsoleTextAttribute (hstdout, attr);
+      EnterCriticalSection (&color_lock);
+      if (color_bool)
+        {
+          SetConsoleTextAttribute (hstdout, attr);
+        }
+      LeaveCriticalSection (&color_lock);
     }
   else
     printf (sgr_start, sgr_seq);

###

This patch is also available at:
https://github.com/StephanTLavavej/mingw-distro/blob/fbe3e6bcb952c8b48af0eb=
f4c0e13c08ffb8aea4/grep-lock.patch

Thank you very much for your continued maintenance of grep.

STL




Acknowledgement sent to Stephan Lavavej <stl@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-grep@HIDDEN. Full text available.
Report forwarded to bug-grep@HIDDEN:
bug#28083; Package grep. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 17 Nov 2021 20:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.